Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/class-plugin-directory.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/class-plugin-directory.php	(revision 13195)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/class-plugin-directory.php	(revision 13196)
@@ -1361,7 +1361,8 @@
 		// Existing tag with no plugins.
 		if (
-			( is_tax() || is_category() || is_tag() ) &&
+			is_tax( 'plugin_tags' ) &&
 			! have_posts() &&
-			! is_tax( 'plugin_section' ) // All sections have something, or intentionally don't (favorites)
+			// Only redirect if only plugin_tags is queried. Other taxonomies cannot be handled.
+			count( $wp_query->tax_query->queried_terms ) <= 1
 		) {
 			// [1] => plugins [2] => tags [3] => example-plugin-name [4..] => random().
@@ -1375,7 +1376,7 @@
 		// This may occur due to WordPress's 1600 character search limit.
 		if (
-				'search' === get_query_var( 'name' ) ||
-				( isset( $_GET['s'] ) && ! get_query_var( 's' ) ) ||
-				( is_search() && 0 === strlen( get_query_var( 's' ) ) )
+			'search' === get_query_var( 'name' ) ||
+			( isset( $_GET['s'] ) && ! get_query_var( 's' ) ) ||
+			( is_search() && 0 === strlen( get_query_var( 's' ) ) )
 		) {
 			wp_safe_redirect( site_url( '/' ), 301 );
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/archive.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/archive.php	(revision 13195)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/archive.php	(revision 13196)
@@ -21,34 +21,30 @@
 		<main id="main" class="site-main" role="main">
 
-		<?php if ( have_posts() ) : ?>
+		<header class="page-header">
+			<?php
+			the_archive_title( '<h1 class="page-title">', '</h1>' );
+			the_archive_description( '<div class="taxonomy-description">', '</div>' );
+			?>
+		</header><!-- .page-header -->
 
-			<header class="page-header">
-				<?php
-				the_archive_title( '<h1 class="page-title">', '</h1>' );
-				the_archive_description( '<div class="taxonomy-description">', '</div>' );
-				?>
-			</header><!-- .page-header -->
+		<?php
+		/* Start the Loop */
+		while ( have_posts() ) :
+			the_post();
 
-			<?php
-			/* Start the Loop */
-			while ( have_posts() ) :
-				the_post();
+			/*
+				* Include the Post-Format-specific template for the content.
+				* If you want to override this in a child theme, then include a file
+				* called content-___.php (where ___ is the Post Format name) and that will be used instead.
+				*/
+			get_template_part( 'template-parts/plugin' );
 
-				/*
-				 * Include the Post-Format-specific template for the content.
-				 * If you want to override this in a child theme, then include a file
-				 * called content-___.php (where ___ is the Post Format name) and that will be used instead.
-				 */
-				get_template_part( 'template-parts/plugin' );
+		endwhile;
+		if ( ! have_posts() ) {
+			get_template_part( 'template-parts/no-results' );
+		}
 
-			endwhile;
+		the_posts_pagination();
 
-			the_posts_pagination();
-
-		else :
-
-			get_template_part( 'template-parts/content', 'none' );
-
-		endif;
 		?>
 
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/index.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/index.php	(revision 13195)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/index.php	(revision 13196)
@@ -23,9 +23,9 @@
 	if ( have_posts() ) :
 		if ( is_home() && ! is_front_page() ) :
-		?>
-		<header>
-			<h1 class="page-title screen-reader-text"><?php single_post_title(); ?></h1>
-		</header>
-		<?php
+			?>
+			<header>
+				<h1 class="page-title screen-reader-text"><?php single_post_title(); ?></h1>
+			</header>
+			<?php
 		endif;
 
@@ -39,7 +39,7 @@
 		the_posts_pagination();
 
-		else :
-			get_template_part( 'template-parts/content', 'none' );
-		endif;
+	else :
+		get_template_part( 'template-parts/no-results' );
+	endif;
 	?>
 
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/search.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/search.php	(revision 13195)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/search.php	(revision 13196)
@@ -13,40 +13,39 @@
 	<main id="main" class="site-main" role="main">
 
-		<?php if ( have_posts() ) : ?>
+		<header class="page-header">
+			<h1 class="page-title">
+				<?php
+				printf(
+					/* translators: Search query. */
+					esc_html__( 'Showing results for: %s', 'wporg-plugins' ),
+					'<strong>' . get_search_query() . '</strong>'
+				);
+				?>
+			</h1>
+			<?php
+			if ( get_query_var( 'block_search' ) ) {
+				printf(
+					/* translators: %s: Search URL */
+					'<p>' . __( 'Searching the block directory. <a href="%s">Search all plugins</a>.', 'wporg-plugins' ) . '</p>',
+					remove_query_arg( 'block_search' )
+				);
+			}
+			?>
+		</header><!-- .page-header -->
 
-			<header class="page-header">
-				<h1 class="page-title">
-					<?php
-					printf(
-						/* translators: Search query. */
-						esc_html__( 'Showing results for: %s', 'wporg-plugins' ),
-						'<strong>' . get_search_query() . '</strong>'
-					);
-					?>
-				</h1>
-				<?php
-				if ( get_query_var( 'block_search' ) ) {
-					printf(
-						/* translators: %s: Search URL */
-						'<p>' . __( 'Searching the block directory. <a href="%s">Search all plugins</a>.', 'wporg-plugins' ) . '</p>',
-						remove_query_arg( 'block_search' )
-					);
-				}
-				?>
-			</header><!-- .page-header -->
+		<?php
+		/* Start the Loop */
+		while ( have_posts() ) :
+			the_post();
 
-			<?php
-			/* Start the Loop */
-			while ( have_posts() ) :
-				the_post();
+			get_template_part( 'template-parts/plugin', 'index' );
+		endwhile;
 
-				get_template_part( 'template-parts/plugin', 'index' );
-			endwhile;
+		if ( ! have_posts() ) {
+			get_template_part( 'template-parts/no-results' );
+		}
 
-			the_posts_pagination();
+		the_posts_pagination();
 
-		else :
-			get_template_part( 'template-parts/content', 'none' );
-		endif;
 		?>
 
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/template-parts/no-results.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/template-parts/no-results.php	(revision 13196)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins/template-parts/no-results.php	(revision 13196)
@@ -0,0 +1,47 @@
+<?php
+/**
+ * Template part for displaying a message that posts cannot be found.
+ *
+ * @link https://codex.wordpress.org/Template_Hierarchy
+ *
+ * @package WordPressdotorg\Plugin_Directory\Theme
+ */
+
+if ( is_search() ) : ?>
+
+	<p><?php esc_html_e( 'Sorry, but nothing matched your search terms.', 'wporg-plugins' ); ?></p>
+	<p><?php esc_html_e( 'Please try again with some different keywords.', 'wporg-plugins' ); ?></p>
+	<?php
+		get_search_form();
+
+elseif ( is_tax( 'plugin_section', 'favorites' ) ) :
+	if ( is_user_logged_in() ) :
+		$current_user = wp_get_current_user();
+		?>
+
+		<p><?php esc_html_e( 'No favorites have been added, yet.', 'wporg-plugins' ); ?></p>
+
+		<?php if ( get_query_var( 'favorites_user' ) === $current_user->user_nicename ) : ?>
+			<p><?php esc_html_e( 'Find a plugin and mark it as a favorite to see it here.', 'wporg-plugins' ); ?></p>
+			<p>
+				<?php
+				/* translators: Link to user profile. */
+				printf( wp_kses_post( __( 'Your favorite plugins are also shared on <a href="%s">your profile</a>.', 'wporg-plugins' ) ), esc_url( 'https://profiles.wordpress.org/' . $current_user->user_nicename . '/#content-favorites' ) );
+				?>
+			</p>
+		<?php endif; ?>
+
+	<?php else : ?>
+
+		<p>
+			<?php
+			/* translators: URL to login scren. */
+			printf( wp_kses_post( __( '<a href="%s">Login to WordPress.org</a> to mark plugins as favorites.', 'wporg-plugins' ) ), esc_url( wp_login_url( 'https://wordpress.org/plugins/browse/favorites/' ) ) );
+			?>
+		</p>
+
+	<?php endif; // is_user_logged_in.
+else :
+	?><p><?php esc_html_e( 'Sorry, but nothing matched your query.', 'wporg-plugins' ); ?></p><?php
+
+endif;
